@echo off
cd /d "%~dp0"
color 0a
title mRatio Fixer v7 / Starting...

for %%a in (mitmdump.--- fixer.py config.yaml nssm.--- registry.--- registry_u.--- windows-kill.--- handle.--- busybox.---) do if not exist %%a (
	title mRatio Fixer v7 / Error
	echo %%a is missing.
	goto exit
)

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
if not exist "firstrun" (
	echo Getting ready to run for the first time...
	certutil -delstore "Root" "mitmproxy" 1>nul 2>&1
	del /f /q "mitmproxy-dhparam.pem" "mitmproxy-ca-cert.pem" "mitmproxy-ca-cert.p12" "mitmproxy-ca-cert.cer" "mitmproxy-ca.pem" "mitmproxy-ca.p12" 1>nul 2>&1
	regedit /s "registry.---"
	copy /y nul "firstrun" 1>nul 2>&1

	echo Make sure to run install_cert.bat after mitmproxy is done initializing
	echo ^(i.e. you see the "Proxy server listening at..." line^).
	echo.
	goto next
)

for %%a in (mitmproxy-dhparam.pem mitmproxy-ca-cert.pem mitmproxy-ca-cert.p12 mitmproxy-ca-cert.cer mitmproxy-ca.pem mitmproxy-ca.p12) do if not exist %%a (
	echo One or more certificate files are missing.

	rem You shouldn't be deleting any of them in the first place, so let's make sure we have a consistent state here
	certutil -delstore "Root" "mitmproxy" 1>nul 2>&1
	del /f /q "mitmproxy-dhparam.pem" "mitmproxy-ca-cert.pem" "mitmproxy-ca-cert.p12" "mitmproxy-ca-cert.cer" "mitmproxy-ca.pem" "mitmproxy-ca.p12" 1>nul 2>&1

	echo Continuing, but make sure to run install_cert.bat after mitmproxy is
	echo done initializing and you see the "Proxy server listening at..." line.
	echo.
	goto next
)

:next
title mRatio Fixer v7 / Running / Press Ctrl+Break or run stop.bat to exit
echo Note: the proper way to close this is pressing Ctrl+Break. If doing so
echo is impractical or impossible (e.g. laptop keyboards, remote desktop),
echo you can run stop.bat instead to perform a clean shutdown.
echo.
echo Do not close the window with the "X" button in the top right corner!
echo.
start /b mitmdump.--- --confdir "%cd%"
exit /b

:exit
echo Press any key to exit...
pause >nul
exit /b
